<?xml version="1.0" encoding="utf-8"?>
<!--
  ~ Copyright (C) 2019 The Android Open Source Project
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License
  -->

<manifest
    android:sharedUserId="android.uid.system"
    android:versionCode="1"
    android:versionName="1.0"
    package="com.android.tv.settings"
    xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:tools="http://schemas.android.com/tools">

    <uses-sdk android:minSdkVersion="23"/>

    <uses-permission android:name="android.permission.ACCESS_WIFI_STATE"/>
    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE"/>
    <uses-permission android:name="android.permission.BACKUP"/>
    <uses-permission android:name="android.permission.BLUETOOTH"/>
    <uses-permission android:name="android.permission.BLUETOOTH_ADMIN"/>
    <uses-permission android:name="android.permission.CHANGE_WIFI_STATE"/>
    <uses-permission android:name="android.permission.CLEAR_APP_USER_DATA"/>
    <uses-permission android:name="android.permission.DELETE_CACHE_FILES"/>
    <uses-permission android:name="android.permission.DUMP"/>
    <uses-permission android:name="android.permission.FORCE_STOP_PACKAGES"/>
    <uses-permission android:name="android.permission.GET_ACCOUNTS_PRIVILEGED"/>
    <uses-permission android:name="android.permission.GET_PACKAGE_SIZE"/>
    <uses-permission android:name="android.permission.INJECT_EVENTS"/>
    <uses-permission android:name="android.permission.INTERNET"/>
    <uses-permission android:name="android.permission.MANAGE_ACCOUNTS"/>
    <uses-permission android:name="android.permission.MANAGE_DEBUGGING"/>
    <uses-permission android:name="android.permission.MANAGE_SENSOR_PRIVACY"/>
    <uses-permission android:name="android.permission.MANAGE_SCOPED_ACCESS_DIRECTORY_PERMISSIONS"/>
    <uses-permission android:name="android.permission.MANAGE_USERS"/>
    <uses-permission android:name="android.permission.MANAGE_PROFILE_AND_DEVICE_OWNERS"/>
    <uses-permission android:name="android.permission.READ_PROFILE"/>
    <uses-permission android:name="android.permission.NETWORK_SETTINGS"/>
    <uses-permission android:name="android.permission.OBSERVE_SENSOR_PRIVACY"/>
    <uses-permission android:name="android.permission.OVERRIDE_WIFI_CONFIG"/>
    <uses-permission android:name="android.permission.PEERS_MAC_ADDRESS"/>
    <uses-permission android:name="android.permission.READ_CONTACTS"/>
    <uses-permission android:name="android.permission.REBOOT"/>
    <uses-permission android:name="android.permission.RECORD_AUDIO"/>
    <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE"/>
    <uses-permission android:name="android.permission.RECEIVE_BOOT_COMPLETED"/>
    <uses-permission android:name="android.permission.SET_PREFERRED_APPLICATIONS"/>
    <uses-permission android:name="android.permission.SUGGEST_MANUAL_TIME_AND_ZONE"/>
    <uses-permission android:name="android.permission.SET_TIME"/>
    <uses-permission android:name="android.permission.SET_TIME_ZONE"/>
    <uses-permission android:name="android.permission.USE_RESERVED_DISK"/>
    <uses-permission android:name="android.permission.WRITE_MEDIA_STORAGE"/>
    <uses-permission android:name="android.permission.MANAGE_EXTERNAL_STORAGE"/>
    <uses-permission android:name="android.permission.WRITE_SETTINGS"/>
    <uses-permission android:name="android.permission.WRITE_SECURE_SETTINGS"/>
    <uses-permission android:name="android.permission.REQUEST_DELETE_PACKAGES"/>
    <uses-permission android:name="android.permission.QUERY_ALL_PACKAGES"/>
    <uses-permission android:name="com.google.android.assistant.READ_HOTWORD_STATE"/>
    <uses-permission android:name="com.google.android.assistant.WRITE_HOTWORD_STATE"/>
    <uses-permission android:name="android.permission.MANAGE_SLICE_PERMISSIONS"/>

    <application
         android:name=".TvSettingsApplication"
         android:allowClearUserData="false"
         android:banner="@drawable/ic_launcher_banner_settings"
         android:defaultToDeviceProtectedStorage="true"
         android:directBootAware="true"
         android:forceQueryable="true"
         android:icon="@drawable/logo_settings_color_48dp"
         android:label="@string/settings_app_name"
         android:supportsRtl="true"
         android:theme="@style/Theme.Settings"
         android:usesCleartextTraffic="true">

        <activity
            android:name=".MainSettings"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:label="@string/settings_app_name"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <!-- Intent filter used to display this activity as a settings entry point in the
                 LeanbackLauncher -->
            <intent-filter android:icon="@drawable/ic_settings_launcher_icon"
                 android:label="@string/launcher_settings_app_name"
                 android:priority="3">
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.LEANBACK_SETTINGS"/>
            </intent-filter>
            <!-- Intent filter used to display this activity as a settings entry point in the
                 LeanbackLauncher -->
            <intent-filter android:icon="@drawable/ic_settings_launcher_icon"
                 android:label="@string/launcher_settings_app_name"
                 android:priority="3">
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.LEANBACK_LAUNCHER"/>
            </intent-filter>
        </activity>

        <!-- WifiSetupActivity may be (usually is) started from setup so theme is determined at
             runtime. -->
        <activity
            android:name=".connectivity.setup.WifiSetupActivity"
            android:clearTaskOnLaunch="true"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/Theme.Setup">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="com.android.net.wifi.SETUP_WIFI_NETWORK"/>
                <!-- TODO remove custom action when stop including /packages/apps/Settings -->
                <action android:name="com.android.net.wifi.CANVAS_SETUP_WIFI_NETWORK"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <!-- Enabling this <intent-filter> will signal to Setup that WifiSetupActivity will
                 handle network connectivity (in that case Setup will launch us to handle network
                 duty).
            <intent-filter>
                <action android:name="com.android.net.GET_CONNECTED" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            -->
        </activity>

        <activity
            android:name=".connectivity.NetworkRequestDialogActivity"
            android:theme="@style/Transparent"
            android:excludeFromRecents="true"
            android:launchMode="singleTop"
            android:taskAffinity=".connectivity.NetworkRequestDialogActivity"
            android:exported="true"
            android:permission="android.permission.NETWORK_SETTINGS">
            <intent-filter>
                <action android:name="com.android.settings.wifi.action.NETWORK_REQUEST"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".connectivity.WifiConnectionActivity"
            android:clearTaskOnLaunch="true"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/Theme.SettingsConnectivity" />

        <activity
            android:name=".connectivity.EditProxySettingsActivity"
            android:clearTaskOnLaunch="true"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/Theme.SettingsConnectivity">
            <intent-filter>
                <action android:name="com.android.settings.wifi.action.EDIT_PROXY_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".connectivity.EditIpSettingsActivity"
            android:clearTaskOnLaunch="true"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/Theme.SettingsConnectivity">
            <intent-filter>
                <action android:name="com.android.settings.wifi.action.EDIT_IP_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".connectivity.AddWifiNetworkActivity"
            android:clearTaskOnLaunch="true"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/Theme.SettingsConnectivity" />

        <!-- AccountSliceActivity is just here to facilitate the activity-alias below to eliminate
             the risk of repackaging. -->
        <activity
            android:name=".accounts.AccountSliceActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:theme="@style/TvSettingsActivityTheme"
            android:exported="false" />

        <activity
            android:name=".accounts.AccountsActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="false"
            android:theme="@style/TvSettingsActivityTheme" />

        <activity
            android:name=".accounts.AccountsTrampolineActivity"
            android:excludeFromRecents="true"
            android:enabled="true"
            android:launchMode="singleInstance"
            android:theme="@style/TvSettingsActivityTheme"
            android:exported="false" />

        <activity-alias
            android:name="com.google.android.tv.settings.AccountActivity"
            android:targetActivity=".accounts.AccountsTrampolineActivity"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.USER_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.ACCOUNT_SYNC_SETTINGS"/>
                <action android:name="android.settings.SYNC_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity-alias>

        <activity
            android:name=".accounts.AccountSyncActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
        </activity>

        <!-- ManageUserServicesSliceActivity is just here to facilitate the activity-alias below to
             eliminate the risk of repackaging. -->
        <activity
            android:name=".accounts.ManageUserServicesSliceActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:theme="@style/TvSettingsActivityTheme"
            android:exported="false" />

        <activity-alias
            android:name="com.google.android.tv.settings.ManageUserServicesActivity"
            android:targetActivity=".accounts.ManageUserServicesSliceActivity"
            android:exported="true" >
            <intent-filter android:priority="1">
                <action android:name="android.settings.MANAGE_USER_SERVICES_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity-alias>

        <activity
            android:name=".accounts.RemoveAccountDialog"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true" />

        <activity
            android:name=".accounts.AddAccountWithTypeActivity"
            android:excludeFromRecents="true"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.ADD_ACCOUNT_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.AppsActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.APPLICATION_SETTINGS"/>
                <action android:name="android.settings.MANAGE_APPLICATIONS_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
                <category android:name="com.android.settings.SHORTCUT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.AllAppsActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.APPLICATION_SETTINGS"/>
                <action android:name="android.settings.MANAGE_ALL_APPLICATIONS_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
                <category android:name="com.android.settings.SHORTCUT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.specialaccess.AppUsageAccessActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:taskAffinity=""
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <category android:name="android.intent.category.DEFAULT"/>
                <action android:name="android.settings.USAGE_ACCESS_SETTINGS"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.specialaccess.PictureInPictureActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:taskAffinity=""
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <category android:name="android.intent.category.DEFAULT"/>
                <action android:name="android.settings.PICTURE_IN_PICTURE_SETTINGS"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.specialaccess.SystemAlertActivity"
            android:theme="@style/TvSettingsActivityTheme"
            android:taskAffinity=""
            android:excludeFromRecents="true"
            android:exported="true">
            <intent-filter android:priority="1">
                <category android:name="android.intent.category.DEFAULT"/>
                <action android:name="android.settings.action.MANAGE_OVERLAY_PERMISSION"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <category android:name="android.intent.category.DEFAULT" />
                <action android:name="android.settings.action.MANAGE_OVERLAY_PERMISSION" />
                <data android:scheme="package" />
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.specialaccess.AlarmsAndRemindersActivity"
            android:theme="@style/TvSettingsActivityTheme"
            android:taskAffinity=""
            android:excludeFromRecents="true"
            android:exported="true">
            <intent-filter android:priority="1">
                <category android:name="android.intent.category.DEFAULT" />
                <action android:name="android.settings.REQUEST_SCHEDULE_EXACT_ALARM" />
            </intent-filter>
            <intent-filter android:priority="1">
                <category android:name="android.intent.category.DEFAULT" />
                <action android:name="android.settings.REQUEST_SCHEDULE_EXACT_ALARM" />
                <data android:scheme="package" />
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.AppManagementActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <action android:name="android.intent.action.AUTO_REVOKE_PERMISSIONS" />
                <action android:name="android.settings.APPLICATION_DETAILS_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <data android:scheme="package"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.StorageResetActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <action android:name="android.settings.INTERNAL_STORAGE_SETTINGS"/>
                <action android:name="android.settings.MEMORY_CARD_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <action android:name="android.intent.action.MANAGE_PACKAGE_STORAGE"/>
                <action android:name="android.os.storage.action.MANAGE_STORAGE"/>
            </intent-filter>
        </activity>

        <activity android:name=".device.storage.ResetActivity"
            android:theme="@style/GuidedStepFragmentThemeTwoPanel"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true" />
        <activity
            android:name=".connectivity.NetworkActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <!-- Intent filter used to display this activity as a settings entry point in the
                 LeanbackLauncher -->
            <intent-filter android:icon="@drawable/ic_settings_wifi_active_0_launcher"
                 android:label="@string/launcher_network_app_name"
                 android:priority="2">
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.LEANBACK_SETTINGS"/>
            </intent-filter>
            <intent-filter android:priority="100">
                <action android:name="android.settings.WIFI_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.LEANBACK_SETTINGS"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.LOCATION_SCANNING_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter>
                <action android:name="android.settings.DATA_SAVER_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter>
                <action android:name="android.settings.DATA_ALERT_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter>
                <action android:name="android.settings.panel.action.INTERNET_CONNECTIVITY"/>
                <action android:name="android.settings.panel.action.WIFI"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter>
                <action android:name="android.settings.WIFI_ADD_NETWORKS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.LEANBACK_SETTINGS"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.SecurityActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.settings.SECURITY_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity-alias
            android:name=".users.RestrictedProfileActivityLauncherEntry"
            android:enabled="false"
            android:excludeFromRecents="true"
            android:exported="true"
            android:targetActivity=".system.SecurityActivity">
            <!-- Intent filter used to display this activity as a settings entry point in the
                 LeanbackLauncher -->
            <intent-filter android:icon="@drawable/ic_settings_restricted_profile_launcher"
                 android:label="@string/launcher_restricted_profile_app_name"
                 android:priority="0">
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.LEANBACK_SETTINGS"/>
            </intent-filter>
        </activity-alias>

        <activity
            android:name=".device.displaysound.DisplaySoundActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="com.android.settings.SOUND_SETTINGS"/>
                <action android:name="android.settings.SOUND_SETTINGS"/>
                <action android:name="android.settings.panel.action.VOLUME"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
                <category android:name="com.android.settings.SHORTCUT"/>
            </intent-filter>
        </activity>

        <!-- AmbientSliceActivity is just here to facilitate the activity-alias below to eliminate
             the risk of repackaging. -->
        <activity
            android:name=".device.display.ambient.AmbientSliceActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:theme="@style/TvSettingsActivityTheme"
            android:exported="false" />

        <activity-alias
            android:name="com.google.android.tv.settings.AmbientActivity"
            android:targetActivity=".device.display.ambient.AmbientSliceActivity"
            android:exported="true" >
            <intent-filter android:priority="1">
                <action android:name="com.google.android.tv.settings.ambient"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity-alias>

        <activity
            android:name=".device.display.daydream.DaydreamActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme" />

        <activity
            android:name=".device.display.daydream.DaydreamVoiceAction"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@android:style/Theme.NoTitleBar.Fullscreen">
            <intent-filter>
                <!-- This intent is launched by the SLEEP voice action from Pano Search -->
                <action android:name="com.google.android.pano.action.SLEEP"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.CaptionSetupActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.settings.CAPTIONING_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.DateTimeActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.settings.DATE_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.LocationActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.LOCATION_SOURCE_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
                <category android:name="com.android.settings.SHORTCUT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.development.DevelopmentActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.APPLICATION_DEVELOPMENT_SETTINGS"/>
                <action android:name="com.android.settings.APPLICATION_DEVELOPMENT_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.development.AppPicker"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="false" />

        <activity
            android:name=".inputmethod.KeyboardActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.INPUT_METHOD_SETTINGS"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".autofill.AutofillPickerActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="false"
            android:launchMode="singleInstance"
            android:theme="@style/TvSettingsActivityTheme" />

        <activity
            android:name=".autofill.AutofillPickerTrampolineActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:label="@string/title_select_autofill_service"
            android:launchMode="singleInstance"
            android:theme="@android:style/Theme.NoDisplay">
            <intent-filter android:priority="1">
                <action android:name="android.settings.REQUEST_SET_AUTOFILL_SERVICE"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <data android:scheme="package"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.LanguageActivity"
            android:configChanges="keyboard|keyboardHidden|navigation|locale"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.settings.LOCALE_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".system.InputsActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true" />

        <activity
            android:name=".accessories.BluetoothAccessoryActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme" />

        <activity
            android:name=".accessories.AddAccessoryActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:launchMode="singleTask"
            android:persistableMode="persistNever"
            android:showWhenLocked="true"
            android:taskAffinity=""
            android:turnScreenOn="true">
            <intent-filter>
                <action android:name="com.google.android.intent.action.CONNECT_INPUT"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <receiver
            android:name=".accessories.BluetoothPairingRequest"
            android:exported="true">
            <intent-filter>
                <action android:name="android.bluetooth.device.action.PAIRING_REQUEST"/>
            </intent-filter>
        </receiver>

        <activity
            android:name=".accessories.BluetoothPairingDialog"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:taskAffinity="">
            <intent-filter>
                <action android:name="android.bluetooth.device.action.PAIRING_REQUEST"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".accessories.BluetoothDevicePickerActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true">
            <intent-filter>
                <action android:name="android.bluetooth.devicepicker.action.LAUNCH"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".about.AboutActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <action android:name="android.settings.DEVICE_INFO_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
            </intent-filter>
        </activity>

        <!-- Runs in the phone process since it needs access to the Phone object -->
        <activity
            android:name=".about.StatusActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:process="com.android.phone"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".about.LicenseActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:label="@string/about_legal_license">
            <intent-filter>
                <action android:name="android.settings.LICENSE"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".name.DeviceNameSettingsActivity"
            android:theme="@style/GuidedStepFragmentThemeTwoPanel"
            android:configChanges="keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true">
                <intent-filter>
                    <action android:name="android.settings.DEVICE_NAME" />
                    <category android:name="android.intent.category.DEFAULT" />
                </intent-filter>
        </activity>

        <activity
            android:name=".name.DeviceNameSuggestionActivity"
            android:excludeFromRecents="true"
            android:theme="@style/GuidedStepFragmentThemeTwoPanel"
            android:exported="true">
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="com.android.settings.suggested.category.FIRST_IMPRESSION"/>
            </intent-filter>
            <!-- Default title for suggested setting -->
            <meta-data android:name="com.android.settings.title"
                 android:resource="@string/device_name_suggestion_title"/>
            <!-- Default summary for suggested setting -->
            <meta-data android:name="com.android.settings.summary"
                 android:resource="@string/device_name_suggestion_summary"/>
            <!-- Default icon for our suggested setting -->
            <meta-data android:name="com.android.settings.icon"
                 android:resource="@drawable/ic_device_name_suggestion"/>
        </activity>

        <activity
            android:name=".name.setup.DeviceNameFlowStartActivity"
            android:configChanges="keyboardHidden|navigation"
            android:theme="@style/GuidedStepFragmentThemeTwoPanel"
            android:excludeFromRecents="true"
            android:exported="true"
            android:label="@string/device_name">
            <intent-filter>
                <action android:name="android.settings.START_DEVICE_NAME_FLOW"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <service android:name=".users.UserSwitchListenerService" />

        <receiver
            android:name=".users.UserSwitchListenerService$BootReceiver"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.intent.action.LOCKED_BOOT_COMPLETED"/>
                <action android:name="android.intent.action.BOOT_COMPLETED"/>
            </intent-filter>
        </receiver>

        <receiver
            android:name=".device.storage.DiskReceiver"
            android:exported="true">
            <intent-filter>
                <action android:name="android.os.storage.action.VOLUME_STATE_CHANGED"/>
                <action android:name="com.google.android.tungsten.setupwraith.TV_SETTINGS_POST_SETUP"/>
            </intent-filter>
        </receiver>

        <service
            android:name=".users.RestrictedProfilePinService"
            android:exported="false" />

        <service
            android:name=".device.storage.SettingsStorageService$Impl"
            android:exported="false" />

        <activity
            android:name=".device.storage.NewStorageActivity"
            android:excludeFromRecents="true"
            android:exported="false"
            android:taskAffinity="">
            <intent-filter>
                <action android:name="com.android.tv.settings.action.NEW_STORAGE"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.storage.UnmountActivity"
            android:excludeFromRecents="true"
            android:exported="false">
            <intent-filter>
                <action android:name="com.android.tv.settings.action.UNMOUNT_STORAGE"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.storage.FormatActivity"
            android:excludeFromRecents="true"
            android:exported="false" />

        <activity
            android:name=".device.storage.MigrateStorageActivity"
            android:excludeFromRecents="true"
            android:exported="false">
            <intent-filter>
                <action android:name="com.android.tv.settings.action.MIGRATE_STORAGE"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.MoveAppActivity"
            android:excludeFromRecents="true"
            android:exported="false">
            <intent-filter>
                <action android:name="com.android.tv.settings.action.MOVE_APP"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".accessories.BluetoothRequestPermissionActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:label="@string/bluetooth_permission_request"
            android:permission="android.permission.BLUETOOTH"
            android:theme="@android:style/Theme.NoDisplay">
            <intent-filter android:priority="1">
                <action android:name="android.bluetooth.adapter.action.REQUEST_DISCOVERABLE"/>
                <action android:name="android.bluetooth.adapter.action.REQUEST_ENABLE"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <!-- Triggered when user-selected home app isn't encryption aware -->
        <activity
            android:name=".system.FallbackHome"
            android:configChanges="locale|keyboard|keyboardHidden|navigation|screenLayout|fontScale|uiMode|orientation|screenSize|smallestScreenSize|layoutDirection"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/FallbackHome">
            <intent-filter android:priority="-1000">
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.HOME"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".inputmethod.InputMethodAndSubtypeEnablerActivity"
            android:clearTaskOnLaunch="true"
            android:exported="true"
            android:label=""
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <action android:name="android.settings.INPUT_METHOD_SUBTYPE_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.MAIN"/>
                <category android:name="android.intent.category.VOICE_LAUNCH"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".device.apps.specialaccess.ExternalSourcesActivity"
            android:exported="true"
            android:label="@string/install_other_apps"
            android:taskAffinity=""
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <action android:name="android.settings.MANAGE_UNKNOWN_APP_SOURCES"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.MANAGE_UNKNOWN_APP_SOURCES"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <data android:scheme="package"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".privacy.NotificationAccessActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <action android:name="android.settings.ACTION_NOTIFICATION_LISTENER_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".privacy.SensorToggleActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1">
                <action android:name="android.settings.MANAGE_MICROPHONE_PRIVACY"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.MANAGE_CAMERA_PRIVACY"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <!-- Stub intent filters for CTS TODO: implement something useful -->
        <activity
            android:name=".EmptyStubActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@android:style/Theme.NoDisplay">
            <intent-filter>
                <action android:name="android.settings.WEBVIEW_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.IGNORE_BATTERY_OPTIMIZATION_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.REQUEST_IGNORE_BATTERY_OPTIMIZATIONS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <data android:scheme="package"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.IGNORE_BACKGROUND_DATA_RESTRICTIONS_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <data android:scheme="package"/>
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.MANAGE_DEFAULT_APPS_SETTINGS"/>
                <action android:name="android.settings.HOME_SETTINGS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <!-- FileProvider to share a generated license html file. Note that
             "com.android.settings.files" is set here as its authorities because a Uri permission
             grant should be allowed to share a file with an external browser but it is allowed only
             for Settings' authorities in ActivityManagerService. -->
        <provider
            android:name="androidx.core.content.FileProvider"
            android:authorities="com.android.settings.files"
            android:exported="false"
            android:grantUriPermissions="true">
            <meta-data
                android:name="android.support.FILE_PROVIDER_PATHS"
                android:resource="@xml/file_paths"/>
        </provider>

        <provider
            android:name=".name.SuggestionContentProvider"
            android:authorities="com.android.tv.settings.name"
            android:exported="true">
            <intent-filter>
                <action android:name="com.android.settings.action.SUGGESTION_STATE_PROVIDER"/>
            </intent-filter>
        </provider>

        <activity
            android:name=".deviceadmin.ProfileOwnerAdd"
            android:clearTaskOnLaunch="true"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1000">
                <action android:name="android.app.action.SET_PROFILE_OWNER"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".ActionDisabledByAdminDialog"
            android:excludeFromRecents="true"
            android:exported="true"
            android:launchMode="singleTop"
            android:taskAffinity="com.android.tv.settings"
            android:theme="@style/ActionDisabledDialogTheme">
            <intent-filter android:priority="1">
                <action android:name="android.settings.SHOW_ADMIN_SUPPORT_DETAILS"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".deviceadmin.DeviceAdminAdd"
            android:clearTaskOnLaunch="true"
            android:excludeFromRecents="true"
            android:exported="true">
            <intent-filter>
                <action android:name="android.app.action.ADD_DEVICE_ADMIN"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <activity
            android:name=".slice.SliceActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="3">
                <action android:name="android.settings.SLICE_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <!-- It is critical to make sure that the OEM links below all have "android:priority" larger
             than 0 to make sure that non-System apps, whose "android:priority" are capped to 0 at
             runtime by the system, cannot "abduct" the intent. -->
        <activity-alias
            android:name=".oemlink.AccessibilityCaptionActivity"
            android:targetActivity=".system.CaptionSetupActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:noHistory="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1" >
                <action android:name="android.settings.ACCESSIBILITY_CAPTION_TV_OEM_LINK" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity-alias>

        <activity
            android:name=".oemlink.AccessibilitySettingsActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1" >
                <action android:name="android.settings.ACCESSIBILITY_TV_OEM_LINK" />
                <action android:name="android.settings.ACCESSIBILITY_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".oemlink.AccessibilityServiceActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1" >
                <action android:name="android.settings.ACCESSIBILITY_SHORTCUT_SERVICES_TV_OEM_LINK" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity-alias
            android:name=".oemlink.NetworkSettingsActivity"
            android:targetActivity=".connectivity.NetworkActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1" >
                <action android:name="android.settings.NETWORK_SETTINGS_TV_OEM_LINK" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity-alias>

        <activity
            android:name=".oemlink.FactoryResetActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/ActionDisabledDialogTheme">
            <intent-filter android:priority="1" >
                <action android:name="android.settings.FACTORY_RESET_TV_OEM_LINK" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <intent-filter android:priority="1" >
                <action android:name="android.intent.action.FACTORY_RESET" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name="com.android.tv.settings.vendor.VendorActivity"
            android:configChanges="keyboard|keyboardHidden|navigation"
            android:excludeFromRecents="true"
            android:exported="true"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter android:priority="1" >
                <action android:name="com.google.android.tv.settings.vendor"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <receiver
            android:name=".DeviceSettingBroadcastReceiver"
            android:exported="true"
            android:permission="android.permission.READ_PRIVILEGED_PHONE_STATE">
            <intent-filter>
                <action android:name="com.android.tv.settings.REBOOT_DEVICE"/>
                <action android:name="com.android.tv.settings.REMOVE_WIFI"/>
            </intent-filter>
        </receiver>

        <activity
            android:name=".accessories.BluetoothActionActivity"
            android:exported="false" />

        <service
            android:name=".accessories.BluetoothDevicesService"
            android:exported="false" />

        <service
            android:name=".service.SettingsService"
            android:exported="true">
            <intent-filter>
                <action android:name="com.android.tv.settings.SETTINGS_SERVICE" />
            </intent-filter>
        </service>
        <provider
            android:name=".accessories.ConnectedDevicesSliceProvider"
            android:authorities="com.android.tv.settings.accessories.sliceprovider"
            android:exported="true">
            <intent-filter>
                <action android:name="android.intent.action.VIEW"/>
                <category android:name="android.app.slice.category.SLICE"/>
            </intent-filter>
        </provider>

        <receiver
            android:name=".accessories.ConnectedDevicesSliceBroadcastReceiver"
            android:exported="false">
        </receiver>

        <receiver
            android:name=".BootReceiver"
            android:enabled="true"
            android:exported="true">
            <intent-filter>
                <action android:name="android.intent.action.BOOT_COMPLETED"/>
            </intent-filter>
        </receiver>

        <activity android:name=".RemoteBugreportActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:permission="android.permission.DUMP"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.settings.SHOW_REMOTE_BUGREPORT_DIALOG" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".enterprise.EnterprisePrivacySettingsActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:label="@string/enterprise_privacy_settings"
            android:theme="@style/TvSettingsActivityTheme">
            <intent-filter>
                <action android:name="android.settings.ENTERPRISE_PRIVACY_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

    </application>

</manifest>
